#include <ESP8266WiFi.h>
#include "ESP8266WiFi.h"
#define APLIST_SIZE 6

/* Set these to your desired credentials. */
const char *ssid = "ESPAP_5";
const char *password = "thereisnospoon";
String wifi_ssid;

//setup a accesspoint list
byte listAP[APLIST_SIZE];


/**************************HELPER FUNCTIONS*********************************/

void updateAP(int ID, byte value)
{
  if ((ID>APLIST_SIZE)||(ID<1)) return;
  listAP[ID-1] = value;
}


void scanAP(){
  //before scan set all rssi to 0;
  for (int i = 0;i< APLIST_SIZE;i++)
  { listAP[i] = (byte)0;}
  //start to scan
 int n = WiFi.scanNetworks();
 if(n!=0)
 {
  // check the scanned network
  for(int i = 0; i<n; i++){
    wifi_ssid = WiFi.SSID(i);
    if(wifi_ssid.substring(0,5)=="ESPAP"){
      int ID = wifi_ssid.substring(6).toInt();
      byte value = char(-int(WiFi.RSSI(i)));
      updateAP(ID,value);
    }
  }
 } 
}


void serialSend(){
   if (Serial.available()){
      //empty the serial port
      while(Serial.available()){
        Serial.read();
      }
      //output all the byte data by sequence
      for (int i = 0; i<APLIST_SIZE;i++){
        Serial.write(char(i+1));
        Serial.write(listAP[i]);
      }
      return;
     }
    return;
    }

/************************MAIN************************************/

void setup() {
  Serial.begin(115200);
  // Set WiFi to station mode and disconnect from an AP if it was previously connected
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  WiFi.softAP(ssid, password, 5);//set at channel 5

  //initialize aplist
  for (int i = 0;i< APLIST_SIZE;i++)
  {
    listAP[i] = (byte)0;
  }
  delay(20);
}


void loop() {
  scanAP();
  serialSend();
  delay(50);
}


